from browser import document, html, window, timer, aio
from browser.local_storage import storage
from random import randrange
from javascript import JSON
import re, time
log = print

canvas = document.querySelector("pg-viz-canvas")
editor = document.querySelector("pg-editor")

def printToConsole(s, Class="stdout"): editor.printToConsole(s, Class)
def clearConsole(): editor.clearConsole()

def drawLine(x1, y1, x2, y2): canvas.drawLine(x1, y1, x2, y2)
def drawText(text, x, y, fillStyle="black", font="32px sans-serif"): canvas.drawText(text, x, y, fillStyle, font)
def drawRect(x, y, w, h, fillStyle=None): canvas.drawRect(x, y, w, h, fillStyle)
def drawTriangle(x1, y1, x2, y2, x3, y3, fillStyle=None): canvas.drawTriangle(x1, y1, x2, y2, x3, y3, fillStyle)
def drawCircle(x, y, r, fillStyle=None): canvas.drawCircle(x, y, r, fillStyle)
def drawImage(img, x, y, flip=None): canvas.drawImage(img, x, y, flip)
def drawInput(x=0, y=0, w=None, h=None): canvas.drawInput(x, y, w, h) 
def setStrokeStyle(value): canvas.strokeStyle = value
def setFillStyle(value): canvas.fillStyle = value
def setLineWidth(value): canvas.lineWidth = value
def playSound(name): window.audioPlayer.play(name)
def getInput(): return canvas.inputSrc 
def getPixelData(x=0, y=0, w=None, h=None): return canvas.getImageData(x, y, w, h)
def setPixelData(data, x=0, y=0): canvas.putImageData(data, x, y)
def createSlider(text="", min=0, max=100, step=1): return canvas.createSlider(text, min, max, step) 
def createTextBox(label="", text="", size=3): return canvas.createTextBox(label, text, size)
display = canvas.mainCanvas

window.animationId = -1
window.startTime = 0

def composeCode(code):
	code = f'''
def print(s, Class="stdout"):
	editor.printToConsole(s, Class)

canvas.reset()
mouseX       = canvas.mouseX
mouseY       = canvas.mouseY
mouseClicked = canvas.mouseClicked
keyClicked   = canvas.keyClicked
runTime   = 0
deltaTime = 0
startTime = -1

{code}

def animate(timestamp):
    global runTime, deltaTime, startTime, mouseX, mouseY, mouseClicked, keyClicked
    if startTime==-1: startTime = timestamp
    deltaTime = timestamp - startTime - runTime
    runTime = timestamp - startTime
    mouseX = canvas.mouseX
    mouseY = canvas.mouseY
    mouseClicked = canvas.mouseClicked
    keyClicked   = canvas.keyClicked
    
    canvas.reset()
    loop()
    canvas.mouseClicked = ""
    canvas.keyClicked = ""
    if window.animationId!=-1: window.animationId = timer.request_animation_frame(animate)

def main():
	log("running main")
	if "setup" in syms: setup()
	if "loop" in syms:
		window.isLooping = True
		window.animationId = timer.request_animation_frame(animate)
	else: window.isLooping = False

syms = dir()
main()
'''
	return code

def start():
	global nofocus
	window.audioPlayer.ctx = window.AudioContext.new()
	canvas.clearActions()
	if not nofocus: canvas.focus()
	clearConsole()
	code = window.mainEditor.getValue()
	#log("?code="+window.btoa(code))
	storage[window.EDITOR_STORAGE_KEY] = code
	code = composeCode(code)
	#log("running: "+code)
	try:
		exec(code, globals())#, {"print": print})
		if window.isLooping: run.innerHTML = "Stop"
	except Exception as e:
		printToConsole(str(e), "stderr")
		return e

def stop():
	run.innerHTML="Run"
	timer.cancel_animation_frame(window.animationId)
	window.animationId = -1

async def startstop():
	await window.currentSpritesheet.loadAll()
	if (run.innerHTML=="Stop"): stop()	
	else: start()

log("hello developer")
run = document.querySelector("pg-editor .run")
run.bind("click", lambda ev: aio.run(startstop()))
nofocus = False
if "code" in document.query:
	if "nofocus" in document.query: nofocus = True
	code = window.atob(document.query["code"])
	log(code)
	window.mainEditor.setValue(code)
	document.querySelector("pg-editor").style.display = "none"
	document.body.style.display = "block"
	document.querySelector("pg-viz").style.overflow = "hidden"
	document.querySelector("pg-viz .header").style.display = "none"
	document.querySelector("pg-viz .doc").style.display = "none"
	playSound = lambda name: None # disable sound
	aio.run(startstop())
